const path = require('path')

const BUILD_PATH = process.env.npm_package_buildPath

function preset (context, opts = {}) {
  const config = {
    presets: [
      ['es2015', opts],
    ],
    plugins: [
      // react
      'babel-plugin-transform-react-jsx',
      'babel-plugin-syntax-jsx',
      'babel-plugin-transform-react-display-name',

      // stage 3
      'syntax-trailing-function-commas',

      // stage 2
      'transform-class-properties',
      'transform-object-rest-spread',
      'transform-async-functions',
      'transform-regenerator', // not needed in Chrome or Firefox. Soon won't be needed in Edge or Safari.

      'transform-async-to-generator',

      // stage 1
      'transform-export-extensions',
    ],
  }

  if (opts.runtime !== false) {
    config.plugins.unshift('transform-runtime')
  }

  // need to use @stayradiated/pkg to generate css.json
  if (opts['css-modules'] === true) {
    config.plugins.push(['css-modules-transform', {
      generateScopedName: '[folder]_[local]_[hash:base36:5]',
      preprocessCss: path.join(__dirname, 'preprocessCSS.js'),
      extractCss: path.join(BUILD_PATH, 'index.css'),
    }])
  }

  return config
}

module.exports = preset
